<?php

namespace App\Models;

use App\Utils\DateUtils;
use App\Entities\ComandaFechamento\ComandaFechamento;

class ComandaFechamentoModel extends ModelEntity {
	protected $table = 'comanda_fechamento';
	protected $primaryKey = 'id';
	protected $returnType = 'array';
	protected $allowedFields = [ 
			'comanda_id',
			'tipo_fechamento',
			'valor',
			'criado_por',
			'data_criacao',
			'hora_criacao',
			'atualizado_por',
			'data_atualizacao',
			'hora_atualizacao'
	];
	protected $useSoftDeletes = false;
	protected $skipValidation = true;
	protected $useTimestamps = false;
	protected $createdField = 'data_criacao';
	protected $updatedField = 'data_atualizacao';

	public function registerComandaFechamento(ComandaFechamento $comandaFechamento): void {

		$data = $comandaFechamento->toArray( true );
		$id = $this->insert( $data );
		$comandaFechamento->setId( $id );

	}

	public function updateComandaFechamentoByID(int $id, ComandaFechamento $comandaFechamento): bool {

		$data = $comandaFechamento->toArray( true );
		$data ['data_atualizacao'] = DateUtils::today();
		$data ['hora_atualizacao'] = DateUtils::now_time();
		$binds = [ 
				'id' => $id
		];
		$sets = $this->generateUpdateSets( $data, $binds );
		$sql = "update comanda_fechamento $sets where id = :id:";
		log_message( 'info', $sql );
		log_message( 'info', json_encode( $data ) );
		log_message( 'info', json_encode( $binds ) );
		$query = $this->db->query( $sql, $binds );
		return $query->connID->affected_rows === 1;

	}

}
